/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MysqlTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MysqlTrait{}

// MysqlTrait struct for MysqlTrait
type MysqlTrait struct {
	Dsn       *string                     `json:"dsn,omitempty"`
	Host      *string                     `json:"host,omitempty"`
	Port      *int32                      `json:"port,omitempty"`
	Username  *string                     `json:"username,omitempty"`
	Password  *string                     `json:"password,omitempty"`
	Database  *string                     `json:"database,omitempty"`
	SshConfig NullableMysqlTraitSshConfig `json:"sshConfig,omitempty"`
	Ssl       NullableString              `json:"ssl,omitempty"`
	Tls       *string                     `json:"tls,omitempty"`
}

// NewMysqlTrait instantiates a new MysqlTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMysqlTrait() *MysqlTrait {
	this := MysqlTrait{}
	return &this
}

// NewMysqlTraitWithDefaults instantiates a new MysqlTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMysqlTraitWithDefaults() *MysqlTrait {
	this := MysqlTrait{}
	return &this
}

// GetDsn returns the Dsn field value if set, zero value otherwise.
func (o *MysqlTrait) GetDsn() string {
	if o == nil || IsNil(o.Dsn) {
		var ret string
		return ret
	}
	return *o.Dsn
}

// GetDsnOk returns a tuple with the Dsn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetDsnOk() (*string, bool) {
	if o == nil || IsNil(o.Dsn) {
		return nil, false
	}
	return o.Dsn, true
}

// HasDsn returns a boolean if a field has been set.
func (o *MysqlTrait) HasDsn() bool {
	if o != nil && !IsNil(o.Dsn) {
		return true
	}

	return false
}

// SetDsn gets a reference to the given string and assigns it to the Dsn field.
func (o *MysqlTrait) SetDsn(v string) {
	o.Dsn = &v
}

// GetHost returns the Host field value if set, zero value otherwise.
func (o *MysqlTrait) GetHost() string {
	if o == nil || IsNil(o.Host) {
		var ret string
		return ret
	}
	return *o.Host
}

// GetHostOk returns a tuple with the Host field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetHostOk() (*string, bool) {
	if o == nil || IsNil(o.Host) {
		return nil, false
	}
	return o.Host, true
}

// HasHost returns a boolean if a field has been set.
func (o *MysqlTrait) HasHost() bool {
	if o != nil && !IsNil(o.Host) {
		return true
	}

	return false
}

// SetHost gets a reference to the given string and assigns it to the Host field.
func (o *MysqlTrait) SetHost(v string) {
	o.Host = &v
}

// GetPort returns the Port field value if set, zero value otherwise.
func (o *MysqlTrait) GetPort() int32 {
	if o == nil || IsNil(o.Port) {
		var ret int32
		return ret
	}
	return *o.Port
}

// GetPortOk returns a tuple with the Port field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetPortOk() (*int32, bool) {
	if o == nil || IsNil(o.Port) {
		return nil, false
	}
	return o.Port, true
}

// HasPort returns a boolean if a field has been set.
func (o *MysqlTrait) HasPort() bool {
	if o != nil && !IsNil(o.Port) {
		return true
	}

	return false
}

// SetPort gets a reference to the given int32 and assigns it to the Port field.
func (o *MysqlTrait) SetPort(v int32) {
	o.Port = &v
}

// GetUsername returns the Username field value if set, zero value otherwise.
func (o *MysqlTrait) GetUsername() string {
	if o == nil || IsNil(o.Username) {
		var ret string
		return ret
	}
	return *o.Username
}

// GetUsernameOk returns a tuple with the Username field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetUsernameOk() (*string, bool) {
	if o == nil || IsNil(o.Username) {
		return nil, false
	}
	return o.Username, true
}

// HasUsername returns a boolean if a field has been set.
func (o *MysqlTrait) HasUsername() bool {
	if o != nil && !IsNil(o.Username) {
		return true
	}

	return false
}

// SetUsername gets a reference to the given string and assigns it to the Username field.
func (o *MysqlTrait) SetUsername(v string) {
	o.Username = &v
}

// GetPassword returns the Password field value if set, zero value otherwise.
func (o *MysqlTrait) GetPassword() string {
	if o == nil || IsNil(o.Password) {
		var ret string
		return ret
	}
	return *o.Password
}

// GetPasswordOk returns a tuple with the Password field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetPasswordOk() (*string, bool) {
	if o == nil || IsNil(o.Password) {
		return nil, false
	}
	return o.Password, true
}

// HasPassword returns a boolean if a field has been set.
func (o *MysqlTrait) HasPassword() bool {
	if o != nil && !IsNil(o.Password) {
		return true
	}

	return false
}

// SetPassword gets a reference to the given string and assigns it to the Password field.
func (o *MysqlTrait) SetPassword(v string) {
	o.Password = &v
}

// GetDatabase returns the Database field value if set, zero value otherwise.
func (o *MysqlTrait) GetDatabase() string {
	if o == nil || IsNil(o.Database) {
		var ret string
		return ret
	}
	return *o.Database
}

// GetDatabaseOk returns a tuple with the Database field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetDatabaseOk() (*string, bool) {
	if o == nil || IsNil(o.Database) {
		return nil, false
	}
	return o.Database, true
}

// HasDatabase returns a boolean if a field has been set.
func (o *MysqlTrait) HasDatabase() bool {
	if o != nil && !IsNil(o.Database) {
		return true
	}

	return false
}

// SetDatabase gets a reference to the given string and assigns it to the Database field.
func (o *MysqlTrait) SetDatabase(v string) {
	o.Database = &v
}

// GetSshConfig returns the SshConfig field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlTrait) GetSshConfig() MysqlTraitSshConfig {
	if o == nil || IsNil(o.SshConfig.Get()) {
		var ret MysqlTraitSshConfig
		return ret
	}
	return *o.SshConfig.Get()
}

// GetSshConfigOk returns a tuple with the SshConfig field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlTrait) GetSshConfigOk() (*MysqlTraitSshConfig, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshConfig.Get(), o.SshConfig.IsSet()
}

// HasSshConfig returns a boolean if a field has been set.
func (o *MysqlTrait) HasSshConfig() bool {
	if o != nil && o.SshConfig.IsSet() {
		return true
	}

	return false
}

// SetSshConfig gets a reference to the given NullableMysqlTraitSshConfig and assigns it to the SshConfig field.
func (o *MysqlTrait) SetSshConfig(v MysqlTraitSshConfig) {
	o.SshConfig.Set(&v)
}

// SetSshConfigNil sets the value for SshConfig to be an explicit nil
func (o *MysqlTrait) SetSshConfigNil() {
	o.SshConfig.Set(nil)
}

// UnsetSshConfig ensures that no value is present for SshConfig, not even an explicit nil
func (o *MysqlTrait) UnsetSshConfig() {
	o.SshConfig.Unset()
}

// GetSsl returns the Ssl field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MysqlTrait) GetSsl() string {
	if o == nil || IsNil(o.Ssl.Get()) {
		var ret string
		return ret
	}
	return *o.Ssl.Get()
}

// GetSslOk returns a tuple with the Ssl field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MysqlTrait) GetSslOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Ssl.Get(), o.Ssl.IsSet()
}

// HasSsl returns a boolean if a field has been set.
func (o *MysqlTrait) HasSsl() bool {
	if o != nil && o.Ssl.IsSet() {
		return true
	}

	return false
}

// SetSsl gets a reference to the given NullableString and assigns it to the Ssl field.
func (o *MysqlTrait) SetSsl(v string) {
	o.Ssl.Set(&v)
}

// SetSslNil sets the value for Ssl to be an explicit nil
func (o *MysqlTrait) SetSslNil() {
	o.Ssl.Set(nil)
}

// UnsetSsl ensures that no value is present for Ssl, not even an explicit nil
func (o *MysqlTrait) UnsetSsl() {
	o.Ssl.Unset()
}

// GetTls returns the Tls field value if set, zero value otherwise.
func (o *MysqlTrait) GetTls() string {
	if o == nil || IsNil(o.Tls) {
		var ret string
		return ret
	}
	return *o.Tls
}

// GetTlsOk returns a tuple with the Tls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlTrait) GetTlsOk() (*string, bool) {
	if o == nil || IsNil(o.Tls) {
		return nil, false
	}
	return o.Tls, true
}

// HasTls returns a boolean if a field has been set.
func (o *MysqlTrait) HasTls() bool {
	if o != nil && !IsNil(o.Tls) {
		return true
	}

	return false
}

// SetTls gets a reference to the given string and assigns it to the Tls field.
func (o *MysqlTrait) SetTls(v string) {
	o.Tls = &v
}

func (o MysqlTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MysqlTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Dsn) {
		toSerialize["dsn"] = o.Dsn
	}
	if !IsNil(o.Host) {
		toSerialize["host"] = o.Host
	}
	if !IsNil(o.Port) {
		toSerialize["port"] = o.Port
	}
	if !IsNil(o.Username) {
		toSerialize["username"] = o.Username
	}
	if !IsNil(o.Password) {
		toSerialize["password"] = o.Password
	}
	if !IsNil(o.Database) {
		toSerialize["database"] = o.Database
	}
	if o.SshConfig.IsSet() {
		toSerialize["sshConfig"] = o.SshConfig.Get()
	}
	if o.Ssl.IsSet() {
		toSerialize["ssl"] = o.Ssl.Get()
	}
	if !IsNil(o.Tls) {
		toSerialize["tls"] = o.Tls
	}
	return toSerialize, nil
}

type NullableMysqlTrait struct {
	value *MysqlTrait
	isSet bool
}

func (v NullableMysqlTrait) Get() *MysqlTrait {
	return v.value
}

func (v *NullableMysqlTrait) Set(val *MysqlTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableMysqlTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableMysqlTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMysqlTrait(val *MysqlTrait) *NullableMysqlTrait {
	return &NullableMysqlTrait{value: val, isSet: true}
}

func (v NullableMysqlTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMysqlTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
